Bug 511120 - Feature: Resource Restriction
Feature: Resource Restriction
Status: CLOSED CURRENTRELEASE
Product: Red Hat Enterprise MRG
Classification: Red Hat
Component: grid (Show other bugs)
Development
All Linux
medium Severity medium
: 1.2
: ---
Assigned To: Robert Rati
MRG Quality Engineering
: FutureFeature
Depends On: 532832
Blocks: 527551
  Show dependency treegraph
 
Reported: 2009-07-13 15:09 EDT by Robert Rati
Modified: 2010-02-12 10:57 EST (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Enhancement
Doc Text:
Grid enhancement Added feature to constrain resources. This prevents a job consuming more resources than is allowed for the slot the job is running on.
Story Points: ---
Clone Of:
Environment:
Last Closed: 2010-02-12 10:57:26 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Verification script (964 bytes, text/plain)
2009-11-02 11:56 EST, Jan Sarenik
no flags Details
Current verification script (1.17 KB, application/x-sh)
2009-11-05 12:30 EST, Jan Sarenik
no flags Details

  None (edit)
Description Robert Rati 2009-07-13 15:09:45 EDT
Description of problem:
condor allows resource division in slot definition, but nothing will prevent the application from incorrectly advertising it's resource requirements and then using more resources than is allowed for the slot it is matched with.  This feature would prevent a job from consuming more resources than have been allocated to a slot by strictly enforcing the slot's resource allocation.

Version-Release number of selected component (if applicable):


How reproducible:


Steps to Reproduce:
1.
2.
3.
  
Actual results:


Expected results:


Additional info:
Comment 1 Robert Rati 2009-07-13 16:18:49 EDT
This feature makes use of condor's USER_JOB_WRAPPER to run all jobs with a
wrapper that will enforce memory, swap, and disk usage for the slot the job is
running on.

It is configured by adding:

USER_JOB_WRAPPER=$(LIBEXEC)/condor_limits_wrapper.sh

Condor will write the job's classad and slot classad into files specified by
the environment variables _CONDOR_JOB_AD and _CONDOR_MACHINE_AD.
Comment 3 Irina Boverman 2009-10-28 14:03:35 EDT
Release note added. If any revisions are required, please set the 
"requires_release_notes" flag to "?" and edit the "Release Notes" field accordingly.
All revisions will be proofread by the Engineering Content Services team.

New Contents:
Added resource constraining feature preventing a job from consuming more resources than is allowed for the slot the job is running on (511120)
Comment 6 Jan Sarenik 2009-11-02 11:56:55 EST
Created attachment 367163 [details]
Verification script

Simple verification script.

Requires only condor to be installed.
Comment 7 Jan Sarenik 2009-11-02 12:04:06 EST
Everything works fine with condor-7.4.1-0.2.el5
on both i386 and x86_64.

But condor-7.4.1-0.2.el4 works only no x86_64 as
expected. On i386 it does not limit virtual memory.

Please check my attached script if I am doing anything
wrong and then check what can cause different behaviour
on i386.
Comment 8 Jan Sarenik 2009-11-04 03:10:43 EST
This one depends on Bug 532832.
Comment 9 Lana Brindley 2009-11-04 23:05:30 EST
Release note updated. If any revisions are required, please set the 
"requires_release_notes"  flag to "?" and edit the "Release Notes" field accordingly.
All revisions will be proofread by the Engineering Content Services team.

Diffed Contents:
@@ -1 +1,3 @@
-Added resource constraining feature preventing a job from consuming more resources than is allowed for the slot the job is running on (511120)+Grid enhancement
+
+Added feature to constrain resources. This prevents a job consuming more resources than is allowed for the slot the job is running on.
Comment 10 Jan Sarenik 2009-11-05 12:30:03 EST
Created attachment 367671 [details]
Current verification script

Memory and disk limits are correctly set
on all supported systems, i.e. RHEL4 and 5,
i386 and x86_64.
Comment 11 Jan Sarenik 2010-02-12 10:57:26 EST
This was already released as part of 1.2, just not tracked by ERRATA.

Note You need to log in before you can comment on or make changes to this bug.